
-- # import Category
-- # import Functor

{--------------------------------------------------------------------------
    The category of sets and non-dependent functions
 --------------------------------------------------------------------------}
CategorySet : Category
CategorySet =
  ( Set			    -- objects
  , \A B -> A -> B	    -- arrows
  , \A x -> x		    -- id
  , \A B C f g x -> f (g x) -- composition
  , ( \A B f	      -> fol-plugin(__fol_extensionality)
    , \A B f	      -> fol-plugin(__fol_extensionality)
    , \A B C D f g h  -> fol-plugin(__fol_extensionality)
    )
  )

{--------------------------------------------------------------------------
    The category of (small) categories
 --------------------------------------------------------------------------}

-- The identity functor
ID : (CC : Category) -> Functor CC CC
ID CC =
    ( \A -> A
    , \A B f -> f
    , ( \A	    -> fol-plugin()
      , \A B C f g  -> fol-plugin()
      )
    )

-- Functor composition
COMPOSE : (CC, DD, EE : Category) ->
	   Functor DD EE -> Functor CC DD -> Functor CC EE
COMPOSE CC DD EE F G =
    ( \A      -> F.Map (G.Map A)
    , \A B f  -> F.map (G.Map A) (G.Map B) (G.map A B f)
    , ( \A	   -> fol-plugin( F.proofs.respId (G.Map A)
				, G.proofs.respId A
				)
      , \A B C f g -> fol-plugin( F.proofs.respCompose (G.Map A) (G.Map B) (G.Map C)
						       (G.map B C f) (G.map A B g)
				, G.proofs.respCompose A B C f g
				)
      )
    )

CategoryCat : Category
CategoryCat =
  ( Category
  , Functor
  , ID
  , COMPOSE
  , ( \CC DD (Map, map, proofs) -> ?
    , \CC DD F -> assert-plugin(silent)
    , \CC DD EE FF F G H -> assert-plugin(silent)
    )
  )

